Zen API

- Home
- Help Topics
- Types by Category
- All Types
- Files

All Classes Files Functions Variables Typedefs Macros Groups Pages
Public Member Functions
kFile Class Reference
kApi/Io

## Description

Represents a file stream.

Inheritance diagram for kFile:

## Public Member Functions
kStatus | kFile_Close (kFile file)
| Performs any outstanding I/O operations and closes the underlying file. More...
kStatus | kFile_Construct (kFile *file, const kChar *path, kFileMode mode, kAlloc allocator)
| Constructs a kFile object. More...
kStatus | kFile_Copy (const kChar *source, const kChar *destination)
| Copies a file to the specified destination. More...
kStatus | kFile_CopyEx (const kChar *source, const kChar *destination, kCallbackFx progress, kPointer context)
| Copies a file to the specified destination with progress feedback. More...
kStatus | kFile_Delete (const kChar *path)
| Deletes the specified file. More...
kBool | kFile_Exists (const kChar *fileName)
| Reports whether the specified file exists. More...
k64u | kFile_Length (kFile file)
| Returns the current length of the file. More...
kStatus | kFile_Load (const kChar *path, void *data, kSize *size, kAlloc allocator)
| Reads the specified file and provides the file contents in an array. More...
kStatus | kFile_LoadTo (const kChar *path, void *data, kSize capacity)
| Reads the specified file into the provided array. More...
kStatus | kFile_Move (const kChar *source, const kChar *destination)
| Moves a file to the specified destination. More...
kStatus | kFile_MoveEx (const kChar *source, const kChar *destination, kCallbackFx progress, kPointer context)
| Moves a file to the specified destination with progress feedback. More...
k64u | kFile_Position (kFile file)
| Returns the current position of the read/write pointer, relative to the beginning of the file. More...
kStatus | kFile_Save (const kChar *path, const kByte *data, kSize size)
| Saves the specified data to the specified file. More...
kStatus | kFile_SetReadBuffer (kFile file, kSize size)
| Sets the size of the buffer used for reading. More...
kStatus | kFile_SetWriteBuffer (kFile file, kSize size)
| Sets the size of the buffer used for writing. More...
k64u | kFile_Size (const kChar *fileName)
| Reports the size the specified file, in bytes. More...
kStatus | kFile_TempName (kChar *name, kSize capacity)
| Gets a temporary file name. More...
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
k64u | kStream_BytesRead (kStream stream)
| Reports the number of bytes read from this stream. More...
k64u | kStream_BytesWritten (kStream stream)
| Reports the number of bytes written to this stream. More...
kStatus | kStream_ClearStats (kStream stream)
| Clears stream statistics (e.g. More...
kStatus | kStream_Copy (kStream stream, kStream source, kSize size)
| Copies the specified number of bytes from one stream to another. More...
kStatus | kStream_CopyEx (kStream stream, kStream source, kSize size, kCallbackFx progress, kPointer context)
| Copies the specified number of bytes from one stream to another, with progress feedback. More...
kStatus | kStream_Flush (kStream stream)
| Flushes buffered writes to the underlying medium. More...
kStatus | kStream_Read (kStream stream, void *buffer, kSize size)
| Reads the specified number of bytes from the stream. More...
kStatus | kStream_ReadSome (kStream stream, void *buffer, kSize minCount, kSize maxCount, kSize *bytesRead)
| Reads up to the specified number of bytes from the stream. More...
kStatus | kStream_Seek (kStream stream, k64s offset, kSeekOrigin origin)
| Moves the read/write pointer to the specified location. More...
kStatus | kStream_Write (kStream stream, const void *buffer, kSize size)
| Writes the specified number of bytes to the stream. More...

## Member Function Documentation

kStatus kFile_Close | ( | kFile | file | ) |

Performs any outstanding I/O operations and closes the underlying file.

The purpose of the Close method is to provide an opportunity to finalize I/O and report any errors before destroying a file object. If the Destroy method is called without having closed the file, the Destroy method will close the file and ignore any errors.

The Close method should only be called once per file object. After calling the Close method, any operations other than Destroy will produce an undefined result.

Parameters

  file | File object.

Returns
  Operation status.

kStatus kFile_Construct | ( | kFile * | file,
|  | const kChar * | path,
|  | kFileMode | mode,
|  | kAlloc | allocator
| ) |  |

Constructs a kFile object.

Parameters

  file | Destination for the constructed object handle.
  path | Path to the file.
  mode | Specifies how to open the file.
  allocator | Memory allocator (or kNULL for default).

Returns
  Operation status.

kStatus kFile_Copy | ( | const kChar * | source,
|  | const kChar * | destination
| ) |  |

Copies a file to the specified destination.

Parameters

  source | Source file path.
  destination | Destination file path.

Returns
  Operation status.

kStatus kFile_CopyEx | ( | const kChar * | source,
|  | const kChar * | destination,
|  | kCallbackFx | progress,
|  | kPointer | context
| ) |  |

Copies a file to the specified destination with progress feedback.

The specified callback will be invoked to provide feedback on the progress of the operation. The callback 'args' parameter will receive a k32u value representing the percentage completed. The callback is guaranteed to be called at least once if the operation is successful, with a progress value of 100%.

Parameters

  source | Source file path.
  destination | Destination file path.
  progress | Optional progress callback (can be kNULL).
  context | Callback context.

Returns
  Operation status.

kStatus kFile_Delete | ( | const kChar * | path | ) |

Deletes the specified file.

Parameters

  path | File path.

Returns
  Operation status.

kBool kFile_Exists | ( | const kChar * | fileName | ) |

Reports whether the specified file exists.

Parameters

  fileName | Path to the file.

Returns
  kTRUE if the file exists; kFALSE otherwise.

k64u kFile_Length | ( | kFile | file | ) |

Returns the current length of the file.

Parameters

  file | File object.

Returns
  Length of the file, in bytes.

kStatus kFile_Load | ( | const kChar * | path,
|  | void * | data,
|  | kSize * | size,
|  | kAlloc | allocator
| ) |  |

Reads the specified file and provides the file contents in an array.

Parameters

  path | Path to file.
  data | Receives a pointer to the file contents.
  size | Receives the size of the file contents.
  allocator | Memory allocator (or kNULL for default).

Returns
  Operation status.

kStatus kFile_LoadTo | ( | const kChar * | path,
|  | void * | data,
|  | kSize | capacity
| ) |  |

Reads the specified file into the provided array.

Parameters

  path | Path to file.
  data | Receives file contents.
  capacity | Amount of file to read, in bytes.

Returns
  Operation status (kERROR_INCOMPLETE if file is smaller than capacity).

kStatus kFile_Move | ( | const kChar * | source,
|  | const kChar * | destination
| ) |  |

Moves a file to the specified destination.

Parameters

  source | Source file path.
  destination | Destination file path.

Returns
  Operation status.

kStatus kFile_MoveEx | ( | const kChar * | source,
|  | const kChar * | destination,
|  | kCallbackFx | progress,
|  | kPointer | context
| ) |  |

Moves a file to the specified destination with progress feedback.

The specified callback will be invoked to provide feedback on the progress of the operation. The callback 'args' parameter will receive a k32u value representing the percentage completed. The callback is guaranteed to be called at least once if the operation is successful, with a progress value of 100%.

Parameters

  source | Source file path.
  destination | Destination file path.
  progress | Optional progress callback (can be kNULL).
  context | Callback context.

Returns
  Operation status.

k64u kFile_Position | ( | kFile | file | ) |

Returns the current position of the read/write pointer, relative to the beginning of the file.

Parameters

  file | File object.

Returns
  Offset of read/write pointer from beginning of file.

kStatus kFile_Save | ( | const kChar * | path,
|  | const kByte * | data,
|  | kSize | size
| ) |  |

Saves the specified data to the specified file.

Parameters

  path | Path to file.
  data | Pointer to the file contents.
  size | Size of the file contents.

Returns
  Operation status.

kStatus kFile_SetReadBuffer | ( | kFile | file,
|  | kSize | size
| ) |  |

Sets the size of the buffer used for reading.

Buffering can improve efficiency when performing several small read operations. The default buffer size is 0.

Parameters

  file | File object.
  size | Size of the buffer.

Returns
  Operation status.

kStatus kFile_SetWriteBuffer | ( | kFile | file,
|  | kSize | size
| ) |  |

Sets the size of the buffer used for writing.

Buffering can improve efficiency when performing several small write operations. The default buffer size is 0.

Parameters

  file | File object.
  size | Size of the buffer.

Returns
  Operation status.

k64u kFile_Size | ( | const kChar * | fileName | ) |

Reports the size the specified file, in bytes.

Parameters

  fileName | Path to the file.

Returns
  Size of the file, in bytes.

kStatus kFile_TempName | ( | kChar * | name,
|  | kSize | capacity
| ) |  |

Gets a temporary file name.

Parameters

  name | Receives temporary file name.
  capacity | Maximum number of characters (including null terminator).

Returns
  Operation status.

kAlloc kObject_Alloc | ( | kObject | object | ) |
| inherited

Gets the memory allocator associated with this object.

Most objects are constructed with an allocator, which is used to allocate the memory required by the object. Objects retain a reference to this allocator to enable further allocations and to free memory when the object is destroyed.

Parameters

  object | Object.

Returns
  Memory allocator.

See also
  kAlloc, kObject_Alloc_

kStatus kObject_Clone | ( | kObject * | object,
|  | kObject | source,
|  | kAlloc | allocator
| ) |  |
| inherited

Constructs a new object by copying an existing object, including any aggregated child elements.

If the source object is an object collection (e.g. kArrayList<kString>), any aggregated child objects are also cloned. In this case, the kObject_Dispose method can be used to free the cloned collection and its associated elements.

This method will fail if the source object (or an aggregated child element) does not support cloning.

Parameters

  object | Receives the constructed object.
  source | Source object.
  allocator | Memory allocator (or kNULL for default).

Returns
  Operation status.

See also
  kObject_Dispose

kStatus kObject_Destroy | ( | kObject | object | ) |
| inherited

Destroys the object.

The kObject_Destroy method destroys the object itself and any resources that are owned by the object. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kStatus kObject_Dispose | ( | kObject | object | ) |
| inherited

Destroys the object and any aggregated child elements.

The kObject_Dispose method destroys the object itself, any resources that are owned by the object, and if the object represents a collection of objects, any child objects in the collection. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kBool kObject_Equals | ( | kObject | object,
|  | kObject | other
| ) |  |
| inherited

Determines whether the object is equal to another object.

By default, objects are compared by reference; objects are considered equal if the given handles refer to the same object instance. However, some classes override the Equals method to provide a more meaningful comparison (e.g. kString).

Parameters

  object | Object.
  other | Object for comparison.

Returns
  kTRUE if the objects are equal.

kSize kObject_HashCode | ( | kObject | object | ) |
| inherited

Gets a hash code representing the state of this object.

By default, objects return a hash code based on the object handle value. However, some classes override the HashCode method to provide a more useful hash (e.g. kString).

Parameters

  object | Object.

Returns
  Hash code.

kBool kObject_Is | ( | kObject | object,
|  | kType | type
| ) |  |
| inherited

Determines whether this object is an instance of the specified type.

This function compares the type of this object with the given type. An object is considered to be an instance of a given type if a) the type represents a class and this object inherits from (or instantiates) that class, or b) the type represents an interface and this object implements the interface.

Parameters

  object | Object.
  type | Type.

Returns
  kTRUE if the object is of the specified type; otherwise kFALSE.

See also
  kObject_Is_, kType_Is

kBool kObject_IsShared | ( | kObject | object | ) |
| inherited

Reports whether the object is currently shared (reference count greater than one).

Objects are initialized with a reference count of one. The kObject_Share method can be used to increment the reference count. The kObject_Destroy and kObject_Dispose methods decrease the reference count, and when the reference count reaches zero, the object is actually destroyed/disposed.

This method can be used to determine if the reference count of an object is currently greater than one.

This method is thread-safe.

Parameters

  object | Object.

Returns
  kTRUE if the object is shared; kFALSE otherwise.

See also
  Reference Counting, kObject_Share

kStatus kObject_SetPool | ( | kObject | object,
|  | kObjectPool | pool
| ) |  |
| inherited

Sets the object pool associated with this object.

Object pools can be used to implement custom lifecycle management. If an object has an assigned pool, then the kObjectPool_Reclaim method will be called just prior to destruction, to provide an opportunity for the object to be reclaimed.

Parameters

  object | Object.
  pool | Pool object (or kNULL to clear the pool assignment).

Returns
  Operation status.

kStatus kObject_Share | ( | kObject | object | ) |
| inherited

Increments the reference count associated with this object.

This method is thread-safe.

Parameters

  object | Object.

Returns
  Operation status.

See also
  reference-counting

kSize kObject_Size | ( | kObject | object | ) |
| inherited

Estimates the memory consumed by this object, including any aggregated child elements.

This method can be optionally overridden by kObject-derived classes to report the amount of memory consumed by an object. The default implementation reports only the size of the class instance (additional allocations performed by the class are excluded).

Parameters

  object | Object.

Returns
  Object size, in bytes.

kType kObject_Type | ( | kObject | object | ) |
| inherited

Returns the type of the object.

Each object is an instance of a specific class type. The type handle returned by this function can be used to learn about the class.

Parameters

  object | Object.

Returns
  Type.

See also
  kType, kObject_Type_

k64u kStream_BytesRead | ( | kStream | stream | ) |
| inherited

Reports the number of bytes read from this stream.

Parameters

  stream | Stream object.

Returns
  Count of bytes read.

k64u kStream_BytesWritten | ( | kStream | stream | ) |
| inherited

Reports the number of bytes written to this stream.

Parameters

  stream | Stream object.

Returns
  Count of bytes written.

kStatus kStream_ClearStats | ( | kStream | stream | ) |
| inherited

Clears stream statistics (e.g.

BytesRead, BytesWritten).

Parameters

  stream | Stream object.

Returns
  Operation Status

kStatus kStream_Copy | ( | kStream | stream,
|  | kStream | source,
|  | kSize | size
| ) |  |
| inherited

Copies the specified number of bytes from one stream to another.

Parameters

  stream | Destination stream.
  source | Source stream.
  size | Count of bytes to be copied.

Returns
  Operation status.

kStatus kStream_CopyEx | ( | kStream | stream,
|  | kStream | source,
|  | kSize | size,
|  | kCallbackFx | progress,
|  | kPointer | context
| ) |  |
| inherited

Copies the specified number of bytes from one stream to another, with progress feedback.

The specified callback will be invoked to provide feedback on the progress of the operation. The callback 'args' parameter will receive a k32u value representing the percentage completed. The callback is guaranteed to be called at least once if the operation is successful, with a progress value of 100%.

Parameters

  stream | Destination stream.
  source | Source stream.
  size | Count of bytes to be copied.
  progress | Optional progress callback (can be kNULL).
  context | Callback context.

Returns
  Operation status.

kStatus kStream_Flush | ( | kStream | stream | ) |
| inherited

Flushes buffered writes to the underlying medium.

Parameters

  stream | Stream object.

Returns
  Operation status.

kStatus kStream_Read | ( | kStream | stream,
|  | void * | buffer,
|  | kSize | size
| ) |  |
| inherited

Reads the specified number of bytes from the stream.

Parameters

  stream | Stream object.
  buffer | Destination for bytes that are read.
  size | Count of bytes to read.

Returns
  Operation status.

kStatus kStream_ReadSome | ( | kStream | stream,
|  | void * | buffer,
|  | kSize | minCount,
|  | kSize | maxCount,
|  | kSize * | bytesRead
| ) |  |
| inherited

Reads up to the specified number of bytes from the stream.

Parameters

  stream | Stream object.
  buffer | Destination for bytes that are read.
  minCount | Minimum count of bytes to read.
  maxCount | Maximum count of bytes to read.
  bytesRead | Receives count of bytes read.

Returns
  Operation status.

kStatus kStream_Seek | ( | kStream | stream,
|  | k64s | offset,
|  | kSeekOrigin | origin
| ) |  |
| inherited

Moves the read/write pointer to the specified location.

Parameters

  stream | Stream object.
  offset | Offset by which to adjust the read/write pointer.
  origin | Origin to which movement is relative (i.e. begin, current, end).

Returns
  Operation status.

kStatus kStream_Write | ( | kStream | stream,
|  | const void * | buffer,
|  | kSize | size
| ) |  |
| inherited

Writes the specified number of bytes to the stream.

Parameters

  stream | Stream object.
  buffer | Bytes to be written to the stream.
  size | Count of bytes to be written.

Returns
  Operation status.

The documentation for this class was generated from the following file:

- Io/kFile.h